<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryRef"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="模块编码" prop="code">
        <el-input
          v-model="queryParams.code"
          placeholder="请输入模块编码"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input
          v-model="queryParams.sort"
          placeholder="请输入排序"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <!-- <el-form-item label="创建时间" prop=" createTime">
        <el-date-picker
          clearable
          v-model="queryParams.createTime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择创建时间"
        >
        </el-date-picker>
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['system:module:add']"
          >新增</el-button
        >
      </el-col>

      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:module:remove']"
          >删除</el-button
        >
      </el-col>

      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="moduleList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="主键" align="center" prop="id" /> -->
      <el-table-column label="模块编码" align="center" prop="code" />
      <!-- <el-table-column label="栏目" align="center" prop="columnIds" /> -->
      <el-table-column label="排序" align="center" prop="sort" />
      <!-- <el-table-column
        label="创建时间"
        align="center"
        prop=" createTime"
        width="180"
      >
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column> -->
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:module:edit']"
            >修改</el-button
          >
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:module:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改首页栏目模块对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="moduleRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="模块编码" prop="code">
          <el-input v-model="form.code" placeholder="请输入模块编码" />
        </el-form-item>
        <el-form-item label="栏目" prop="columnIds">
          <!-- <el-input
            v-model="form.columnIds"
            type="textarea"
            placeholder="请输入内容"
          /> -->
          <!-- <el-tree-select
            style="width: 100%"
            v-model="form.columnIds"
            multiple
            :props="{
              value: 'id',
              label: 'columnName',
              children: 'children',
              disabled: (data) => {
                return data.parentId == 0 ? true : false;
              },
            }"
            :data="columnList"
          /> -->
          <el-tree-select
            style="width: 100%"
            v-model="form.columnIds"
            :data="columnList"
            value-key="id"
            :props="{ value: 'id', label: 'label', children: 'children' }"
            multiple
            check-strictly
            placeholder="请选择栏目"
          >
            <!-- <el-option
              v-for="item in columnList"
              :key="item.id"
              :label="item.label"
              :value="item.id"
            >
            </el-option> -->
          </el-tree-select>
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input
            type="number"
            v-model="form.sort"
            placeholder="请输入排序"
          />
        </el-form-item>
        <!-- <el-form-item label="创建时间" prop=" createTime">
          <el-date-picker
            clearable
            v-model="form.createTime"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择创建时间"
          >
          </el-date-picker>
        </el-form-item> -->
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Module">
import {
  listModule,
  getModule,
  delModule,
  addModule,
  updateModule,
  listMore,
} from "@/api/system/module";
import {
  listColumn,
  listColumn2,
  getColumn,
  delColumn,
  addColumn,
  listByColumnId,
  updateColumn,
  columnTree,
} from "@/api/system/column";
const { proxy } = getCurrentInstance();

const moduleList = ref([]);
const columnList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    code: null,
    columnIds: null,
    sort: null,
    createTime: null,
  },
  rules: {},
});

const { queryParams, form, rules } = toRefs(data);

/** 查询首页栏目模块列表 */
function getList() {
  loading.value = true;
  listModule(queryParams.value).then((response) => {
    moduleList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    code: null,
    columnIds: null,
    sort: null,
    createTime: null,
    createBy: null,
    remark: null,
  };
  proxy.resetForm("moduleRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多模块选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加首页栏目模块";
  columnSelect();
}
function columnSelect() {
  columnTree().then((res) => {
    if (res.data[0].length == undefined) {
      columnList.value = res.data;
    } else {
      columnList.value = res.data[0].children;
    }
  });
}

/** 修改按钮操作 */
function handleUpdate(row) {
  proxy.$modal.loading("正在加载中...");
  reset();
  columnSelect();
  const _id = row.id || ids.value;
  setTimeout(function () {
    getModule(_id).then((response) => {
      form.value = response.data;
      form.value.columnIds = response.data.columnIds
        .split(",")
        .map((item) => parseInt(item));

      open.value = true;
      title.value = "修改首页栏目模块";
    });
    proxy.$modal.closeLoading();
  }, 1000);
}

/** 提交按钮 */
function submitForm() {
  form.value.columnIds = form.value.columnIds.toString();
  proxy.$refs["moduleRef"].validate((valid) => {
    if (valid) {
      if (form.value.id != null) {
        updateModule(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addModule(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal
    .confirm('是否确认删除首页栏目模块编号为"' + _ids + '"的数据项？')
    .then(function () {
      return delModule(_ids);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "system/module/export",
    {
      ...queryParams.value,
    },
    `module_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
